Index: src/newlib/libc/unix/basename.c
diff -u /dev/null src/newlib/libc/unix/basename.c:1.1
--- /dev/null	Thu May 12 14:26:03 2005
+++ src/newlib/libc/unix/basename.c	Fri Apr  8 20:48:39 2005
@@ -0,0 +1,25 @@
+/* Copyright 2005 Shaun Jackman
+ * Permission to use, copy, modify, and distribute this software
+ * is freely granted, provided that this notice is preserved.
+ */
+
+#include <libgen.h>
+#include <string.h>
+
+char* 
+_DEFUN (basename, (path),
+	char *path)
+{
+	char *p;
+	if( path == NULL || *path == '\0' )
+		return ".";
+	p = path + strlen(path) - 1;
+	while( *p == '/' ) {
+		if( p == path )
+			return path;
+		*p-- = '\0';
+	}
+	while( p >= path && *p != '/' )
+		p--;
+	return p + 1;
+}
Index: src/newlib/libc/unix/dirname.c
diff -u /dev/null src/newlib/libc/unix/dirname.c:1.1
--- /dev/null	Thu May 12 14:26:03 2005
+++ src/newlib/libc/unix/dirname.c	Fri Apr  8 20:48:39 2005
@@ -0,0 +1,28 @@
+/* Copyright 2005 Shaun Jackman
+ * Permission to use, copy, modify, and distribute this software
+ * is freely granted, provided that this notice is preserved.
+ */
+
+#include <libgen.h>
+#include <string.h>
+
+char *
+_DEFUN (dirname, (path),
+	char *path)
+{
+	char *p;
+	if( path == NULL || *path == '\0' )
+		return ".";
+	p = path + strlen(path) - 1;
+	while( *p == '/' ) {
+		if( p == path )
+			return path;
+		*p-- = '\0';
+	}
+	while( p >= path && *p != '/' )
+		p--;
+	return
+		p < path ? "." :
+		p == path ? "/" :
+		(*p = '\0', path);
+}
Index: src/newlib/libm/common/fdlibm.h
diff -u src/newlib/libm/common/fdlibm.h:1.5 src/newlib/libm/common/fdlibm.h:1.6
--- src/newlib/libm/common/fdlibm.h:1.5	Thu Jun 27 22:48:05 2002
+++ src/newlib/libm/common/fdlibm.h	Fri Feb 25 22:38:46 2005
@@ -71,13 +71,13 @@
 #define FLT_UWORD_IS_FINITE(x) ((x)<0x7f800000L)
 #define FLT_UWORD_IS_NAN(x) ((x)>0x7f800000L)
 #define FLT_UWORD_IS_INFINITE(x) ((x)==0x7f800000L)
-#define FLT_UWORD_MAX 0x7f7fffff
+#define FLT_UWORD_MAX 0x7f7fffffL
 #define FLT_UWORD_EXP_MAX 0x43000000
 #define FLT_UWORD_LOG_MAX 0x42b17217
 #define FLT_UWORD_LOG_2MAX 0x42b2d4fc
 #define HUGE ((float)3.40282346638528860e+38)
 #endif
-#define FLT_UWORD_HALF_MAX (FLT_UWORD_MAX-(1<<23))
+#define FLT_UWORD_HALF_MAX (FLT_UWORD_MAX-(1L<<23))
 #define FLT_LARGEST_EXP (FLT_UWORD_MAX>>23)
 
 /* Many routines check for zero and subnormal numbers.  Such things depend
Index: src/newlib/libm/common/s_fpclassify.c
diff -u src/newlib/libm/common/s_fpclassify.c:1.2 src/newlib/libm/common/s_fpclassify.c:1.3
--- src/newlib/libm/common/s_fpclassify.c:1.2	Fri Jun 27 20:12:01 2003
+++ src/newlib/libm/common/s_fpclassify.c	Thu Feb 24 18:50:06 2005
@@ -9,7 +9,7 @@
 int
 __fpclassifyf (float x)
 {
-  unsigned int w;
+  __uint32_t w;
 
   GET_FLOAT_WORD(w,x);
   
@@ -30,7 +30,7 @@
 int
 __fpclassifyd (double x)
 {
-  unsigned int msw, lsw;
+  __uint32_t msw, lsw;
 
   EXTRACT_WORDS(msw,lsw,x);
 
Index: src/newlib/libm/common/sf_round.c
diff -u src/newlib/libm/common/sf_round.c:1.1 src/newlib/libm/common/sf_round.c:1.3
--- src/newlib/libm/common/sf_round.c:1.1	Fri Jun  7 21:59:56 2002
+++ src/newlib/libm/common/sf_round.c	Thu Feb 24 19:02:35 2005
@@ -19,7 +19,7 @@
 #endif
 {
   int signbit;
-  int w;
+  __uint32_t w;
   /* Most significant word, least significant word. */
   int exponent_less_127;
 
@@ -29,7 +29,7 @@
   signbit = w & 0x80000000;
 
   /* Extract exponent field. */
-  exponent_less_127 = ((w & 0x7f800000) >> 23) - 127;
+  exponent_less_127 = (int)((w & 0x7f800000) >> 23) - 127;
 
   if (exponent_less_127 < 23)
     {
Index: src/newlib/testsuite/include/check.h
diff -u src/newlib/testsuite/include/check.h:1.3 src/newlib/testsuite/include/check.h:1.4
--- src/newlib/testsuite/include/check.h:1.3	Tue May 25 20:52:21 2004
+++ src/newlib/testsuite/include/check.h	Thu Jan 27 20:25:54 2005
@@ -1,4 +1,5 @@
 #include <stdio.h>
+#include <stdlib.h>
 
 #define CHECK(a) { \
   if (!(a)) \
Index: src/newlib/testsuite/newlib.string/memmove1.c
diff -u /dev/null src/newlib/testsuite/newlib.string/memmove1.c:1.1
--- /dev/null	Thu May 12 14:26:09 2005
+++ src/newlib/testsuite/newlib.string/memmove1.c	Thu Jan 27 20:52:42 2005
@@ -0,0 +1,184 @@
+/* A minor test-program for memmove.
+   Copyright (C) 2005 Axis Communications.
+   All rights reserved.
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions
+   are met:
+
+   1. Redistributions of source code must retain the above copyright
+      notice, this list of conditions and the following disclaimer.
+
+   2. Neither the name of Axis Communications nor the names of its
+      contributors may be used to endorse or promote products derived
+      from this software without specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY AXIS COMMUNICATIONS AND ITS CONTRIBUTORS
+   ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL AXIS
+   COMMUNICATIONS OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
+   INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
+   STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
+   IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.  */
+
+/* Test moves of 0..MAX bytes; overlapping-src-higher,
+   overlapping-src-lower and non-overlapping.  The overlap varies with
+   1..N where N is the size moved.  This means an order of MAX**2
+   iterations.  The size of an octet may seem appropriate for MAX and
+   makes an upper limit for simple testing.  For the CRIS simulator,
+   making this 256 added 90s to the test-run (2GHz P4) while 64 (4s) was
+   enough to spot the bugs that had crept in, hence the number chosen.  */
+#define MAX 64
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+
+#define TOO_MANY_ERRORS 11
+int errors = 0;
+
+#define DEBUGP					\
+ if (errors == TOO_MANY_ERRORS)			\
+   printf ("Further errors omitted\n");		\
+ else if (errors < TOO_MANY_ERRORS)		\
+   printf
+
+/* A safe target-independent memmove.  */
+
+void
+mymemmove (unsigned char *dest, unsigned char *src, size_t n)
+{
+  size_t i;
+
+  if ((src <= dest && src + n <= dest)
+      || src >= dest)
+    while (n-- > 0)
+      *dest++ = *src++;
+  else
+    {
+      dest += n;
+      src += n;
+      while (n-- > 0)
+	*--dest = *--src;
+    }
+}
+
+/* It's either the noinline attribute or forcing the test framework to
+   pass -fno-builtin-memmove.  */
+void
+xmemmove (unsigned char *dest, unsigned char *src, size_t n)
+     __attribute__ ((__noinline__));
+
+void
+xmemmove (unsigned char *dest, unsigned char *src, size_t n)
+{
+  void *retp;
+  retp = memmove (dest, src, n);
+
+  if (retp != dest)
+    {
+      errors++;
+      DEBUGP ("memmove of n bytes returned %p instead of dest=%p\n",
+	      retp, dest);
+    }
+}
+
+
+/* Fill the array with something we can associate with a position, but
+   not exactly the same as the position index.  */
+
+void
+fill (unsigned char dest[MAX*3])
+{
+  size_t i;
+  for (i = 0; i < MAX*3; i++)
+    dest[i] = (10 + i) % MAX;
+}
+
+int
+main (void)
+{
+  size_t i;
+  int errors = 0;
+
+  /* Leave some room before and after the area tested, so we can detect
+     overwrites of up to N bytes, N being the amount tested.  If you
+     want to test using valgrind, make these malloced instead.  */
+  unsigned char from_test[MAX*3];
+  unsigned char to_test[MAX*3];
+  unsigned char from_known[MAX*3];
+  unsigned char to_known[MAX*3];
+
+  /* Non-overlap.  */
+  for (i = 0; i < MAX; i++)
+    {
+      /* Do the memmove first before setting the known array, so we know
+         it didn't change any of the known array.  */
+      fill (from_test);
+      fill (to_test);
+      xmemmove (to_test + MAX, 1 + from_test + MAX, i);
+
+      fill (from_known);
+      fill (to_known);
+      mymemmove (to_known + MAX, 1 + from_known + MAX, i);
+
+      if (memcmp (to_known, to_test, sizeof (to_known)) != 0)
+	{
+	  errors++;
+	  DEBUGP ("memmove failed non-overlap test for %d bytes\n", i);
+	}
+    }
+
+  /* Overlap-from-before.  */
+  for (i = 0; i < MAX; i++)
+    {
+      size_t j;
+      for (j = 0; j < i; j++)
+	{
+	  fill (to_test);
+	  xmemmove (to_test + MAX * 2 - i, to_test + MAX * 2 - i - j, i);
+
+	  fill (to_known);
+	  mymemmove (to_known + MAX * 2 - i, to_known + MAX * 2 - i - j, i);
+
+	  if (memcmp (to_known, to_test, sizeof (to_known)) != 0)
+	    {
+	      errors++;
+	      DEBUGP ("memmove failed for %d bytes,"
+		      " with src %d bytes before dest\n",
+		      i, j);
+	    }
+	}
+    }
+
+  /* Overlap-from-after.  */
+  for (i = 0; i < MAX; i++)
+    {
+      size_t j;
+      for (j = 0; j < i; j++)
+	{
+	  fill (to_test);
+	  xmemmove (to_test + MAX, to_test + MAX + j, i);
+
+	  fill (to_known);
+	  mymemmove (to_known + MAX, to_known + MAX + j, i);
+
+	  if (memcmp (to_known, to_test, sizeof (to_known)) != 0)
+	    {
+	      errors++;
+	      DEBUGP ("memmove failed when moving %d bytes,"
+		      " with src %d bytes after dest\n",
+		      i, j);
+	    }
+	}
+    }
+
+  if (errors != 0)
+    abort ();
+  exit (0);
+}
Index: src/libgloss/ChangeLog
diff -u src/libgloss/ChangeLog:1.96 src/libgloss/ChangeLog:1.112
--- src/libgloss/ChangeLog:1.96	Fri Nov 26 16:43:35 2004
+++ src/libgloss/ChangeLog	Thu May  5 23:15:53 2005
@@ -1,6 +1,99 @@
+2005-05-05  Tobias Anderberg  <tobias.anderberg@axis.com>
+
+        * arm/syscalls.c (get_errno): Fix output register constraint.
+
+2005-05-05  J"orn Rennecke <joern.rennecke@st.com>
+
+        * rs6000/sim-getrusage.S: New file, broken out of:
+        (simulator.S).
+        * rs6000/Makefile.in (SIM_OBJS): Add sim-getrusage.o.
+        (sim-getrusage.o): New rule.
+
+2005-04-28  Shaun Jackman  <sjackman@gmail.com>
+
+	* libgloss/syscalls.c (get_errno): Add an output register constraint.
+
+2005-04-19  Eric Christopher  <echristo@redhat.com>
+
+	* mips/regs.S: Sign extend constants for mips64 and unify
+        address handling.
+
+2005-04-12  Shaun Jackman  <sjackman@gmail.com>
+
+	* libgloss/arm/Makefile.in (RDPMON_BSP): librdpmon.a was empty due 
+	to a typo. Fixed.
+	(RDIMON_BSP): Ditto.
+
+2005-04-12  Richard Sandiford  <rsandifo@redhat.com>
+
+	* mips/array.ld, mips/cfe.ld, mips/dve.ld, mips/idt32.ld,
+	* mips/idt64.ld, mips/idtecoff.ld, mips/idt.ld,
+	* mips/jmr3904app-java.ld, mips/jmr3904app.ld,
+	* mips/jmr3904dram-java.ld, mips/jmr3904dram.ld, mips/lsi.ld,
+	* mips/nullmon.ld, mips/pmon.ld: Keep .init and .fini.
+
+2005-02-08  Antony King  <antony.king@st.com>
+
+	* arm/syscalls.c: Change CHECK_INIT to pass reentrant struct
+	instead of file pointer.
+
+2005-02-01  Hans-Peter Nilsson  <hp@axis.com>
+
+	* cris/Makefile.in (ALL_INSTALL_FILES): New macro.
+	(ALL_INSTALL_FILES_NEWLIB_COPY): New macro.
+	(all): Use ALL_INSTALL_FILES instead of its contents.  Add
+	ALL_INSTALL_FILES_NEWLIB_COPY.
+	($(objroot)/newlib/%, $(objroot)/newlib/libnosys.a): New rules
+
+2005-01-27  Hans-Peter Nilsson  <hp@axis.com>
+
+        * configure.in: Support cris-*-* and crisv32-*-*.
+        * libnosys/configure.in: Ditto.
+	* configure, libnosys/configure: Regenerate.
+	* cris: New directory.
+	* cris/crt0.S, cris/crtn.c, cris/gensyscalls, cris/linunistd.h,
+	cris/outbyte.c, cris/configure.in, cris/crti.c, cris/lcrt0.c,
+	cris/Makefile.in, cris/setup.S, cris/configure: New files.
+
+2005-01-21  Hans-Peter Nilsson  <hp@axis.com>
+
+	* libnosys/warning.h (stub_warning): Remove "warning: " prefix.
+
+2005-01-18  Hans-Peter Nilsson  <hp@axis.com>
+
+	* libnosys/warning.h (link_warning) [HAVE_GNU_LD and HAVE_ELF]:
+	Prefix symbol in section name with __SYMBOL_PREFIX.  Do not use
+	__make_section_unallocated.  Mark magic variable as used.
+
+2005-01-18  Hans-Peter Nilsson  <hp@axis.com>
+
+	* libnosys/configure.in (libc_cv_asm_previous_directive): Set
+	cache-id variable.
+	(libc_cv_asm_popsection_directive): Ditto.
+	(libc_cv_section_attributes): Ditto.
+	(libc_symbol_prefix): Rename from libc_dollar_prefix.  Check for
+	"_" as well, and set __SYMBOL_PREFIX accordingly.
+	* libnosys/configure: Regenerate.
+
+2005-01-18  Hans-Peter Nilsson  <hp@axis.com>
+
+	* libnosys/Makefile.in (LD, AS): Correct obsoleted suffix: Say
+	as-new and ld-new, not as.new and ld.new.
+
+2005-01-14  Hans-Peter Nilsson  <hp@axis.com>
+                                                                                
+        * libnosys/warning.h (__make_section_unallocated)
+        [HAVE_ASM_PREVIOUS_DIRECTIVE, HAVE_ASM_POPSECTION_DIRECTIVE]: Use "\n"
+        instead of ";" to delimit assembly lines.
+                                                                                
+2005-01-07  Paul Brook  <paul@codesourcery.com>
+                                                                                
+	* arm/crt0.S: Call __libc_{init,fini}_array instead of
+	_init/_fini if they exist.
+
 2004-11-26  Paul Brook  <paul@codesourcery.com>
                                                                                 
-        * libc/sys/arm/crt0.S (_start): Add .cantunwind annotation.
+        * arm/crt0.S (_start): Add .cantunwind annotation.
                                                                                 
 2004-10-28  Nick Clifton  <nickc@redhat.com>
 
Index: src/libgloss/configure.in
diff -u src/libgloss/configure.in:1.10 src/libgloss/configure.in:1.11
--- src/libgloss/configure.in:1.10	Thu Oct 28 08:18:18 2004
+++ src/libgloss/configure.in	Thu Jan 27 22:57:26 2005
@@ -85,6 +85,9 @@
   mn10300-*-*)
 	configdirs="${configdirs} mn10300 testsuite"
 	;;
+  cris-*-* | crisv32-*-*)
+	configdirs="${configdirs} cris testsuite"
+	;;
   crx-*-*)
 	configdirs="${configdirs} crx"
 	;;
Index: src/libgloss/arm/crt0.S
diff -u src/libgloss/arm/crt0.S:1.2 src/libgloss/arm/crt0.S:1.3
--- src/libgloss/arm/crt0.S:1.2	Fri Nov 26 16:43:35 2004
+++ src/libgloss/arm/crt0.S	Fri Jan  7 18:01:26 2005
@@ -1,3 +1,4 @@
+#include "newlib.h"
 #include "swi.h"
 
 /* ANSI concatenation macros.  */
@@ -10,6 +11,11 @@
 #error __USER_LABEL_PREFIX is not defined
 #endif
 
+#ifdef HAVE_INITFINI_ARRAY
+#define _init	__libc_init_array
+#define _fini	__libc_fini_array
+#endif
+
 /* .text is used instead of .section .text so it works with arm-aout too.  */
 	.text
 	.code 32
Index: src/libgloss/arm/syscalls.c
diff -u src/libgloss/arm/syscalls.c:1.1 src/libgloss/arm/syscalls.c:1.4
--- src/libgloss/arm/syscalls.c:1.1	Wed Jun  9 19:06:50 2004
+++ src/libgloss/arm/syscalls.c	Thu May  5 23:15:53 2005
@@ -55,20 +55,17 @@
 
 /* following is copied from libc/stdio/local.h to check std streams */
 extern void   _EXFUN(__sinit,(struct _reent *));
-#define CHECK_INIT(fp) \
-  do                                    \
-    {                                   \
-      if ((fp)->_data == 0)             \
-        (fp)->_data = _REENT;           \
-      if (!(fp)->_data->__sdidinit)     \
-        __sinit ((fp)->_data);          \
-    }                                   \
+#define CHECK_INIT(ptr) \
+  do						\
+    {						\
+      if ((ptr) && !(ptr)->__sdidinit)		\
+	__sinit (ptr);				\
+    }						\
   while (0)
 
 /* Adjust our internal handles to stay away from std* handles.  */
 #define FILE_HANDLE_OFFSET (0x20)
 
-static int std_files_checked;
 static int monitor_stdin;
 static int monitor_stdout;
 static int monitor_stderr;
@@ -119,13 +116,8 @@
 static int
 remap_handle (int fh)
 {
-  if (!std_files_checked)
-    {
-       CHECK_INIT(stdin);
-       CHECK_INIT(stdout);
-       CHECK_INIT(stderr);
-       std_files_checked = 1;
-    }
+  CHECK_INIT(_REENT);
+
   if (fh == STDIN_FILENO)
     return monitor_stdin;
   if (fh == STDOUT_FILENO)
@@ -187,7 +179,9 @@
 #ifdef ARM_RDI_MONITOR
   return do_AngelSWI (AngelSWI_Reason_Errno, NULL);
 #else
-  asm ("swi %a0" :: "i" (SWI_GetErrno));
+  register r0 asm("r0");
+  asm ("swi %a1" : "=r"(r0) : "i" (SWI_GetErrno));
+  return r0;
 #endif
 }
 
Index: src/libgloss/cris/configure.in
diff -u /dev/null src/libgloss/cris/configure.in:1.1
--- /dev/null	Thu May 12 14:26:10 2005
+++ src/libgloss/cris/configure.in	Thu Jan 27 22:57:32 2005
@@ -0,0 +1,90 @@
+dnl This file is based on ../mcore/configure.in
+dnl Process this file with autoconf to produce a configure script.
+AC_PREREQ(2.5)dnl
+AC_INIT(Makefile.in)
+
+if test "${enable_shared}" = "yes" ; then
+    echo "Shared libraries not supported for cross compiling, ignored"
+fi
+
+if test "$srcdir" = "." ; then
+  if test "${with_target_subdir}" != "." ; then
+    libgloss_topdir="${srcdir}/${with_multisrctop}../../.."
+  else
+    libgloss_topdir="${srcdir}/${with_multisrctop}../.."
+  fi
+else
+  libgloss_topdir="${srcdir}/../.."
+fi
+AC_CONFIG_AUX_DIR($libgloss_topdir)
+
+AC_CANONICAL_SYSTEM
+AC_ARG_PROGRAM
+
+AC_PROG_INSTALL
+
+# FIXME: We temporarily define our own version of AC_PROG_CC.  This is
+# copied from autoconf 2.12, but does not call AC_PROG_CC_WORKS.  We
+# are probably using a cross compiler, which will not be able to fully
+# link an executable.  This should really be fixed in autoconf
+# itself.
+
+AC_DEFUN(LIB_AC_PROG_CC,
+[AC_BEFORE([$0], [AC_PROG_CPP])dnl
+AC_CHECK_PROG(CC, gcc, gcc)
+if test -z "$CC"; then
+  AC_CHECK_PROG(CC, cc, cc, , , /usr/ucb/cc)
+  test -z "$CC" && AC_MSG_ERROR([no acceptable cc found in \$PATH])
+fi
+
+AC_PROG_CC_GNU
+
+if test $ac_cv_prog_gcc = yes; then
+  GCC=yes
+dnl Check whether -g works, even if CFLAGS is set, in case the package
+dnl plays around with CFLAGS (such as to build both debugging and
+dnl normal versions of a library), tasteless as that idea is.
+  ac_test_CFLAGS="${CFLAGS+set}"
+  ac_save_CFLAGS="$CFLAGS"
+  CFLAGS=
+  AC_PROG_CC_G
+  if test "$ac_test_CFLAGS" = set; then
+    CFLAGS="$ac_save_CFLAGS"
+  elif test $ac_cv_prog_cc_g = yes; then
+    CFLAGS="-g -O2"
+  else
+    CFLAGS="-O2"
+  fi
+else
+  GCC=
+  test "${CFLAGS+set}" = set || CFLAGS="-g"
+fi
+])
+
+LIB_AC_PROG_CC
+AS=${AS-as}
+AC_SUBST(AS)
+AR=${AR-ar}
+AC_SUBST(AR)
+LD=${LD-ld}
+AC_SUBST(LD)
+AC_PROG_RANLIB
+
+host_makefile_frag=${srcdir}/../config/default.mh
+
+dnl We have to assign the same value to other variables because autoconf
+dnl doesn't provide a mechanism to substitute a replacement keyword with
+dnl arbitrary data or pathnames.
+dnl
+host_makefile_frag_path=$host_makefile_frag
+AC_SUBST(host_makefile_frag_path)
+AC_SUBST_FILE(host_makefile_frag)
+
+AC_OUTPUT(Makefile,
+. ${libgloss_topdir}/config-ml.in,
+srcdir=${srcdir}
+target=${target}
+ac_configure_args="${ac_configure_args} --enable-multilib"
+CONFIG_SHELL=${CONFIG_SHELL-/bin/sh}
+libgloss_topdir=${libgloss_topdir}
+)
Index: src/libgloss/cris/crt0.S
diff -u /dev/null src/libgloss/cris/crt0.S:1.1
--- /dev/null	Thu May 12 14:26:10 2005
+++ src/libgloss/cris/crt0.S	Thu Jan 27 22:57:32 2005
@@ -0,0 +1,83 @@
+/* Generic simplistic start-up-stub for CRIS/CRISv32.
+   Copyright (C) 1993-2005 Axis Communications.
+   All rights reserved.
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions
+   are met:
+
+   1. Redistributions of source code must retain the above copyright
+      notice, this list of conditions and the following disclaimer.
+
+   2. Neither the name of Axis Communications nor the names of its
+      contributors may be used to endorse or promote products derived
+      from this software without specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY AXIS COMMUNICATIONS AND ITS CONTRIBUTORS
+   ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL AXIS
+   COMMUNICATIONS OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
+   INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
+   STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
+   IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.  */
+
+#undef cris
+#undef L
+#ifdef __NO_UNDERSCORES__
+#define L(x) x
+#else
+#define L(x) _ ## x
+#endif
+
+; Rudimentary v0..v32-compatible startup stub.
+
+#ifdef __ELF__
+ .section .startup,"ax"
+#endif
+ .global __start
+ nop
+__start:
+ ba 0f
+ nop
+
+ .rept 256 - 2
+ .dword _.int
+ .endr
+
+_.int:
+#ifdef __arch_common_v10_v32
+ ; This is just to allow the multilib to compile without
+ ; hackery: the "common" subset doesn't recognize
+ ; interrupt-return insns.
+#elif __CRIS_arch_version >= 32
+ rete
+ rfe
+#else
+ reti
+ nop
+#endif
+
+0:
+ move.d __setup,$r9
+ jsr $r9
+ nop
+#ifdef __ELF__
+ jsr L(_init)
+ nop
+ move.d L(_fini),$r10
+ jsr L(atexit)
+ nop
+#endif
+ jsr L(main)
+ nop
+ jsr L(exit)
+ nop
+0:
+ nop
+ ba 0b
+ nop
Index: src/libgloss/cris/crti.c
diff -u /dev/null src/libgloss/cris/crti.c:1.1
--- /dev/null	Thu May 12 14:26:10 2005
+++ src/libgloss/cris/crti.c	Thu Jan 27 22:57:32 2005
@@ -0,0 +1,77 @@
+/* Executable and DSO init/fini start for cris*-axis-linux-gnu and simulators
+   Copyright (C) 2000, 2001, 2004, 2005 Axis Communications.
+   All rights reserved.
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions
+   are met:
+
+   1. Redistributions of source code must retain the above copyright
+      notice, this list of conditions and the following disclaimer.
+
+   2. Neither the name of Axis Communications nor the names of its
+      contributors may be used to endorse or promote products derived
+      from this software without specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY AXIS COMMUNICATIONS AND ITS CONTRIBUTORS
+   ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL AXIS
+   COMMUNICATIONS OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
+   INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
+   STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
+   IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.  */
+
+#ifdef __ELF__
+__asm__ (".syntax no_register_prefix");
+
+__asm__ (".section .init\n"
+#ifdef __NO_UNDERSCORES__
+         " .globl _init\n"
+         "_init:\n"
+#else /* not __NO_UNDERSCORES__ */
+         " .globl __init\n"
+         "__init:\n"
+#endif /* not __NO_UNDERSCORES__ */
+         "\tsubq 4,sp\n"
+	 "\tmove srp,[sp]\n"
+#ifdef __PIC__
+         "\tsubq 4,sp\n"
+	 "\tmove.d r0,[sp]\n"
+#if __CRIS_arch_version >= 32
+	 "\tlapc _GLOBAL_OFFSET_TABLE_,$r0\n"
+#else /* not __CRIS_arch_version >= 32 */
+	 "\tmove.d $pc,$r0\n"
+	 "\tsub.d .:GOTOFF,$r0\n"
+#endif /* not __CRIS_arch_version >= 32 */
+#endif /* __PIC__ */
+
+         "\t.section .fini\n"
+#ifdef __NO_UNDERSCORES__
+         " .globl _fini\n"
+         "_fini:\n"
+#else /* not __NO_UNDERSCORES__ */
+         " .globl __fini\n"
+         "__fini:\n"
+#endif /* not __NO_UNDERSCORES__ */
+         "\tsubq 4,sp\n"
+	 "\tmove srp,[sp]\n"
+#ifdef __PIC__
+         "\tsubq 4,sp\n"
+	 "\tmove.d r0,[sp]\n"
+#if __CRIS_arch_version >= 32
+	 "\tlapc _GLOBAL_OFFSET_TABLE_,$r0\n"
+#else /* not __CRIS_arch_version >= 32 */
+	 "\tmove.d $pc,$r0\n"
+	 "\tsub.d .:GOTOFF,$r0\n"
+#endif /* not __CRIS_arch_version >= 32 */
+#endif /* __PIC__ */
+);
+
+#else /* not __ELF__ */
+extern int Dummy;
+#endif /* not __ELF__ */
Index: src/libgloss/cris/crtn.c
diff -u /dev/null src/libgloss/cris/crtn.c:1.1
--- /dev/null	Thu May 12 14:26:10 2005
+++ src/libgloss/cris/crtn.c	Thu Jan 27 22:57:32 2005
@@ -0,0 +1,51 @@
+/* Executable and DSO init/fini end for cris*-axis-linux-gnu and simulators
+   Copyright (C) 2000, 2001, 2004, 2005 Axis Communications.
+   All rights reserved.
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions
+   are met:
+
+   1. Redistributions of source code must retain the above copyright
+      notice, this list of conditions and the following disclaimer.
+
+   2. Neither the name of Axis Communications nor the names of its
+      contributors may be used to endorse or promote products derived
+      from this software without specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY AXIS COMMUNICATIONS AND ITS CONTRIBUTORS
+   ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL AXIS
+   COMMUNICATIONS OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
+   INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
+   STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
+   IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.  */
+
+#ifdef __ELF__
+
+__asm__ (".syntax no_register_prefix");
+
+__asm__ (".section .init\n"
+#ifdef __PIC__
+	 "\tmove.d [sp+],r0\n"
+#endif
+         "\tmove.d [sp+],r9\n"
+         "\tjump r9\n"
+         "\tnop\n"
+
+         "\t.section .fini\n"
+#ifdef __PIC__
+	 "\tmove.d [sp+],r0\n"
+#endif
+         "\tmove.d [sp+],r9\n"
+         "\tjump r9\n"
+         "\tnop\n");
+
+#else
+extern int Dummy;
+#endif
